Contributing
=====================

##Building

```
npm install
```

To build the Javascript do:

```
npm install -g gulp
gulp
```

This lints, tests and minifies. The modularized codebase is packaged using Browserify.

## Running the demo

You can try out portal client mobile in a regular browser. Start up the server:

`npm start`

Then go to (http://localhost:3000)[http://localhost:3000]

## Running unit tests

Unit tests can be found in the `spec` directory and are written using [Jasmine](http://localhost:3000).

Running `gulp test` will run all specs. Run an individual spec like this:

```
npm install -g jasmine #first time
jasmine spec/path/to/spec.js
```

## Directory structure

| Directory        | Purpose                                                                                         |
| -----------------|-------------------------------------------------------------------------------------------------|
| dist             | Build artifacts are generated here                                                              |
| src              | Javascript source files                                                                         |
| html             | The HTML root file used by the mobile sdk                                                       |
| e2e              | Assets for end to end tests / standalone demos                                                  |
| spec             | Unit tests                                                                                      |
| node_modules     | Node modules are used for development dependencies. See the `package.json` file                 |


## Coding guidelines

Please adhere to conventions enforced when running JSHint as part of the Gulp build.

## Quality Attributes

Please be familiar with the [web client quality attributes](https://backbase.atlassian.net/wiki/display/CXP/Web+Client+Quality+Attributes)
 when contributing.
  
## Adding dependencies

Adding a new dependency should be agreed with the team. Using Browserify, its easy to unknowingly include chains
of dependencies and significantly increase the size of a widget engine release. Ensure the following:

* Dependencies use an exact version (No ~ or ^)
* Dependency versions are synced with upstream projects. Browserify will duplicate dependencies that are different versions.
* Use the following command to check the dependencies Browserify includes and their file sizes:

```
browserify --list [PATH] | xargs stat -c "%s %n" | sort -nr | awk '{sum += $1; print $0} END {print "Total size: " sum " bytes"}'
```

Note: These points only apply to core dependencies, not dev dependencies

## Definition of done

All features added to this project should adhere to the Definition of Done:

* Gulp build passes (jshint, tests, packaging)
* Acceptance criteria met
* Functional tests written and passing
* Code has been through PR + code review process by at least two others
