//simple express static server here with local and remote endpoints
var express = require('express');
var cookieParser = require('cookie-parser')
var path = require('path');

var app = express();

app.use(cookieParser());
app.use(function(req, res, next) {
	res.header('Access-Control-Allow-Origin', req.get('Origin') || '*');
	res.header('Access-Control-Allow-Credentials', 'true');
	if (req.method === 'OPTIONS') {
		return res.send(200);
	} else {
		return next();
	}
});

app.use(express.static(__dirname + '/'));

app.get('/contenttemplates/rendered', function (req, res) {

	var body = '<div class="content">';
	body += '<p>I am the content for a request with these params:</p>';
	body += reqInfo(req);
	body += '<p>This image should be requested from the remote location:</p>';
	body += '<p><img src="/e2e/fixtures/remote-image.png"></p>';
	body += '<p>The following cookies were sent:</p>';
	body += cookieInfo(req);
	body += '</div>';
	res.set('Content-Type', 'text/html');
	res.send(body);
});

function reqInfo(req) {
	var body = '';
	var paramsBody = Object.keys(req.query).map(function(key) {
		return '<li>' + key + ': ' + req.query[key] + '</li>';
	}).join('');

	body += '<ul>' + paramsBody + '</ul>';
	return body;
}

function cookieInfo(req) {
	var body = '';
	var cookieBody = Object.keys(req.cookies).map(function(key) {
		return '<li>' + key + ': ' + req.cookie[key] + '</li>';
	}).join('');

	body += '<ul>' + cookieBody + '</ul>';
	return body;
}

console.log('Mobile client demo server running at http://localhost:3000/');
app.listen(3000);