var rewire = require('rewire');
var IFrameBridgeLogStream = rewire('../../src/logging/iframe-bridge-log-stream');
var jsdom = require('jsdom').jsdom;

var document = jsdom('<html><body</body></html>');
var iframe = document.createElement('iframe');
IFrameBridgeLogStream.__set__({
    document: document
});

describe('console plain log stream', function() {
    it('logs via an iframe', function() {
        spyOn(document, 'createElement').and.returnValue(iframe);
        spyOn(iframe, 'setAttribute');

        var logStream = new IFrameBridgeLogStream(document);
        logStream.write({
            name: 'test-logger',
            msg: 'I love mobile',
            levelName: 'warn',
            time: new Date(2016, 3, 16, 17, 55, 12, 234)
        });

        var logSrc = 'log://?type=warn&msg=I love mobile (Sat Apr 16 2016 17:55:12';
        expect(iframe.setAttribute.calls.mostRecent().args[1]).toContain(logSrc);
    })
});