var exposeChildrenPlugin = require('../../src/plugins/expose-children-plugin');

describe('expose children plugin', function () {
    it('exposes info about a widget\'s children on the widget instance', function() {

        var widgetModel = {
            children: [
                { id: '1', name: 'one' },
                { id: '2', name: 'two' },
                { id: '3', name: 'three' }
            ]
        };
        
        var widgetInstance = {
            id: 'widget-x',
            name: 'my-widget'
        };

        var pluginInstance = exposeChildrenPlugin();

        widgetInstance = pluginInstance.preRender(widgetInstance, null, widgetModel);

        expect(widgetInstance.children[0].id).toBe('1');
        expect(widgetInstance.children[0].name).toBe('one');

        expect(widgetInstance.children[1].id).toBe('2');
        expect(widgetInstance.children[1].name).toBe('two');

        expect(widgetInstance.children[2].id).toBe('3');
        expect(widgetInstance.children[2].name).toBe('three');
        
    });
});

