var rewire = require('rewire');
var PageRenderer = rewire('../../src/render/page-renderer');

var mockNamespace = {
    global: {
        window: {
            cxp: {
                mobile: {
                    plugins: {
                    }
                }
            }
        }
    }
};

PageRenderer.__set__(mockNamespace);

var pageRenderer;

describe('page renderer', function () {

    beforeEach(function () {
        pageRenderer = new PageRenderer();
        spyOn(pageRenderer, '_renderForPlatform').and.callFake(function () {});
        spyOn(pageRenderer, '_createLogStreams').and.callFake(function () { return []});

    });

    it('does platform agnostic rendering', function () {
        var root = {};
        var model = {};
        var opts = {
            logLevel: 'debug',
            localContextRoot: '/local',
            remoteContextRoot: '/remote',
            apiRoot: '/api/',
            portalName: 'mobile-portal',
            syncPreferences: [ 'one', 'two', 'three']
        };
        pageRenderer.render(root, model, opts);
        expect(pageRenderer._createLogStreams).toHaveBeenCalledWith('warn');
        expect(pageRenderer._renderForPlatform).toHaveBeenCalledWith(model, jasmine.any(Object), root);
    });
});
