/*global document, DOMParser*/
// inspired by https://gist.github.com/1129031

'use strict';

(function(DOMParser) {
    var proto = DOMParser.prototype,
        nativeParse = proto.parseFromString;

    proto.parseFromString = function(markup, type) {
        if (/^\s*text\/html\s*(?:;|$)/i.test(type)) {
            var doc = document.implementation.createHTMLDocument('');

            if (markup.toLowerCase().indexOf('<!doctype') > -1) {
                doc.documentElement.innerHTML = markup;
            } else {
                doc.body.innerHTML = markup;
            }
            return doc;
        } else {
            return nativeParse.apply(this, arguments);
        }
    };
}(DOMParser));

window.system_scroll = window.scroll;
window.scroll = function(x, y) {
    window.cxp.mobile.scrollTo('' + x, '' + y);
    window.system_scroll(x, y);
};
