'use strict';

//set up some global namespaces
window.cxp = window.cxp || {};
window.mobile = window.mobile || {};
window.cxp.mobile = window.mobile; //mobile references backbase.mobile because native android can only call one object deep

//this is the public interface to start rendering
window.cxp.mobile.render = function(widgetRoot, localContextRoot, remoteContextRoot, apiRoot, portalModel, plugins,
                                    logLevel, portalName) {

    require('./common/dom-parser-polyfill');
    require('javascript-detect-element-resize');
    require('./common/pubsub');

    //simple factory to get the desired renderer for the current platform
    var Renderer;
    var isSafariOrUiWebview = /(iPhone|iPod|iPad).*AppleWebKit/i.test(navigator.userAgent);
    if(isSafariOrUiWebview) {
        console.info('Portal Client Mobile is rendering in iOS mode');
        var iosBridge = require('./platforms/ios/ios-bridge');
        iosBridge.enable();
        Renderer = require('./platforms/ios/ios-page-renderer');
    } else {
        console.info('Portal client mobile is rendering in Android mode');
        Renderer = require('./platforms/android/android-page-renderer');
    }

    window.cxp.mobile.plugins = plugins;
    // filling the gap
    portalModel.contextItemName = portalName;

    //kick off rendering
    var renderer = new Renderer();
    renderer.render(document.getElementById(widgetRoot), portalModel, window.gadgets.pubsub, {
        portalName: portalName,
        localContextRoot: localContextRoot,
        remoteContextRoot: remoteContextRoot,
        apiRoot: apiRoot,
        logLevel: logLevel
    });
};

//legacy interface
window.renderWidget = window.cxp.mobile.render;
