'use strict';

var document = global.document; // jshint ignore:line

/**
 * Write log messages by create iframes whose src attribute contains the log info. This creates network 
 * request which can be intercepted by the native side.
 * @constructor
 */
var IFrameBridgeLogStream = function() {
};

/**
 * Write a bunyan log record
 * @param rec
 */
IFrameBridgeLogStream.prototype.write = function(rec) {
    var iframe = document.createElement('IFRAME');
    iframe.setAttribute('src', 'log://?type=' + rec.levelName + '&msg=' + rec.msg + ' (' + rec.time + ')');
    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;   
};

module.exports = IFrameBridgeLogStream;