'use strict';

module.exports = function(featureList) {

    featureList = featureList || [];

    return {
        name: 'add-feature-plugin',
        postRead: function (widgetModel) {
            if (featureList.length === 0) {
                return widgetModel;
            }

            if (!Array.isArray(widgetModel.features)) {
                widgetModel.features = [];
            }

            featureList.forEach(function (featureName) {
                var widgetModelAlreadyHasFeature = widgetModel.features.some(function (widgetFeature) {
                    return widgetFeature.name === featureName;
                });

                if (!widgetModelAlreadyHasFeature) {
                    widgetModel.features.push({
                        name: featureName,
                        required: false
                    });
                }
            });

            return widgetModel;
        }
    };
};